#include <windows.h>
#include "avisynth.h"
#include <stdio.h>

class dw2DNR : public GenericVideoFilter {
public:
	dw2DNR(PClip _child, float th, bool debug, IScriptEnvironment* env);
	~dw2DNR();
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
	float th_;
	bool debug_;
};

dw2DNR::dw2DNR(PClip _child, float th, bool debug, IScriptEnvironment* env) : GenericVideoFilter(_child) {
    if (!vi.IsYUY2())
        env->ThrowError("dw2DNR: requires YUY2 input.");
    th_=th;
    debug_=debug;
}

dw2DNR::~dw2DNR() {
}

PVideoFrame __stdcall dw2DNR::GetFrame(int n, IScriptEnvironment* env) {
    //*** in-place filtering ***
    PVideoFrame src = child->GetFrame(n, env);
    PVideoFrame dst = env->NewVideoFrame(vi);

    const int   srcpitch   = src->GetPitch();
    const int   dstpitch   = dst->GetPitch();
    const int   rowsize = src->GetRowSize();
    const int   height  = src->GetHeight();

    const BYTE *srcp    = src->GetReadPtr();
    BYTE* dstp     = dst->GetWritePtr();

    unsigned short int ptn[3][8];
    float value[2][3];

    unsigned short int lt;
    unsigned short int cn;
    unsigned short int rt;

    int i;
    int j;
    int k;

    float avg;
    float sb[2];
    int sel_n;
    float tmp[2][3];

//C
//Y
for (int y=2;y<height;y++) {
	//̗AẼ̗f[^荞
	lt=0;
	cn=1;
	i=srcp[(y-2)*srcpitch];
	j=srcp[(y-1)*srcpitch];
	k=srcp[ y   *srcpitch];
	ptn[cn][0]=0;
	ptn[cn][1]=    i;
	ptn[cn][2]=  j  ;
	//ptn[cn][3]=  j+i;
	ptn[cn][4]=k    ;
	//ptn[cn][5]=k  +i;
	//ptn[cn][6]=k+j  ;
	ptn[cn][7]=k+j+i;
	rt=2;
	i=srcp[(y-2)*srcpitch+2];
	j=srcp[(y-1)*srcpitch+2];
	k=srcp[ y   *srcpitch+2];
	ptn[rt][0]=0;
	ptn[rt][1]=    i;
	ptn[rt][2]=  j  ;
	//ptn[rt][3]=  j+i;
	ptn[rt][4]=k    ;
	//ptn[rt][5]=k  +i;
	//ptn[rt][6]=k+j  ;
	ptn[rt][7]=k+j+i;
	
	for (int x=4;x<rowsize;x+=2) {
		
		//EEẼVtg
		lt++;
		if (lt>2) lt=0;
		cn++;
		if (cn>2) cn=0;
		rt++;
		if (rt>2) rt=0;
		
		//Ẽf[^ǂݍ
		i=srcp[(y-2)*srcpitch+x];
		j=srcp[(y-1)*srcpitch+x];
		k=srcp[ y   *srcpitch+x];
		ptn[rt][0]=0;
		ptn[rt][1]=    i;
		ptn[rt][2]=  j  ;
		//ptn[rt][3]=  j+i;
		ptn[rt][4]=k    ;
		//ptn[rt][5]=k  +i;
		//ptn[rt][6]=k+j  ;
		ptn[rt][7]=k+j+i;
		
		//ꂼ̃GbWp^[EQ̕ϒl߂
		value[0][0]=(float)(ptn[lt][0]+ptn[cn][7]+ptn[rt][0])/3.0;
		value[0][1]=(float)(ptn[lt][7]+ptn[cn][0]+ptn[rt][0])/3.0;
		value[0][2]=(float)(ptn[lt][0]+ptn[cn][0]+ptn[rt][7])/3.0;
		value[1][0]=(float)(ptn[lt][2]+ptn[cn][2]+ptn[rt][2])/3.0;
		value[1][1]=(float)(ptn[lt][1]+ptn[cn][1]+ptn[rt][1])/3.0;
		value[1][2]=(float)(ptn[lt][4]+ptn[cn][4]+ptn[rt][4])/3.0;
		
		//]
		avg=(value[0][0]+value[0][1]+value[0][2])/3.0;
		tmp[0][0]=value[0][0]-avg;
		tmp[0][1]=value[0][1]-avg;
		tmp[0][2]=value[0][2]-avg;
		tmp[1][0]=value[1][0]-avg;
		tmp[1][1]=value[1][1]-avg;
		tmp[1][2]=value[1][2]-avg;
		sb[0]=tmp[0][0]*tmp[0][0]+tmp[0][1]*tmp[0][1]+tmp[0][2]*tmp[0][2];
		sb[1]=tmp[1][0]*tmp[1][0]+tmp[1][1]*tmp[1][1]+tmp[1][2]*tmp[1][2];
		sel_n = (sb[0]<sb[1]) ? 1 : 0;
		k=(y-1)*dstpitch+x-2;
		if (sb[sel_n]<th_) {
			dstp[k]=(debug_) ? 254 : (int)(avg+0.5);
		} else {
			dstp[k]=(int)(value[sel_n][0]+0.5);
		}
		
	}//x̃[v
}//ỹ[v

//U
for (int y=2;y<height;y++) {
	//̗AẼ̗f[^荞
	lt=0;
	cn=1;
	i=srcp[(y-2)*srcpitch+1];
	j=srcp[(y-1)*srcpitch+1];
	k=srcp[ y   *srcpitch+1];
	ptn[cn][0]=0;
	ptn[cn][1]=    i;
	ptn[cn][2]=  j  ;
	//ptn[cn][3]=  j+i;
	ptn[cn][4]=k    ;
	//ptn[cn][5]=k  +i;
	//ptn[cn][6]=k+j  ;
	ptn[cn][7]=k+j+i;
	rt=2;
	i=srcp[(y-2)*srcpitch+5];
	j=srcp[(y-1)*srcpitch+5];
	k=srcp[ y   *srcpitch+5];
	ptn[rt][0]=0;
	ptn[rt][1]=    i;
	ptn[rt][2]=  j  ;
	//ptn[rt][3]=  j+i;
	ptn[rt][4]=k    ;
	//ptn[rt][5]=k  +i;
	//ptn[rt][6]=k+j  ;
	ptn[rt][7]=k+j+i;
	
	for (int x=9;x<rowsize;x+=4) {
		
		//EEẼVtg
		lt++;
		if (lt>2) lt=0;
		cn++;
		if (cn>2) cn=0;
		rt++;
		if (rt>2) rt=0;
		
		//Ẽf[^ǂݍ
		i=srcp[(y-2)*srcpitch+x];
		j=srcp[(y-1)*srcpitch+x];
		k=srcp[ y   *srcpitch+x];
		ptn[rt][0]=0;
		ptn[rt][1]=    i;
		ptn[rt][2]=  j  ;
		//ptn[rt][3]=  j+i;
		ptn[rt][4]=k    ;
		//ptn[rt][5]=k  +i;
		//ptn[rt][6]=k+j  ;
		ptn[rt][7]=k+j+i;
		
		//ꂼ̃GbWp^[EQ̕ϒl߂
		value[0][0]=(float)(ptn[lt][0]+ptn[cn][7]+ptn[rt][0])/3.0;
		value[0][1]=(float)(ptn[lt][7]+ptn[cn][0]+ptn[rt][0])/3.0;
		value[0][2]=(float)(ptn[lt][0]+ptn[cn][0]+ptn[rt][7])/3.0;
		value[1][0]=(float)(ptn[lt][2]+ptn[cn][2]+ptn[rt][2])/3.0;
		value[1][1]=(float)(ptn[lt][1]+ptn[cn][1]+ptn[rt][1])/3.0;
		value[1][2]=(float)(ptn[lt][4]+ptn[cn][4]+ptn[rt][4])/3.0;
		
		//]
		avg=(value[0][0]+value[0][1]+value[0][2])/3.0;
		tmp[0][0]=value[0][0]-avg;
		tmp[0][1]=value[0][1]-avg;
		tmp[0][2]=value[0][2]-avg;
		tmp[1][0]=value[1][0]-avg;
		tmp[1][1]=value[1][1]-avg;
		tmp[1][2]=value[1][2]-avg;
		sb[0]=tmp[0][0]*tmp[0][0]+tmp[0][1]*tmp[0][1]+tmp[0][2]*tmp[0][2];
		sb[1]=tmp[1][0]*tmp[1][0]+tmp[1][1]*tmp[1][1]+tmp[1][2]*tmp[1][2];
		sel_n = (sb[0]<sb[1]) ? 1 : 0;
		k=(y-1)*dstpitch+x-4;
		if (sb[sel_n]<th_/2) {
			dstp[k]=(int)(avg+0.5);
		} else {
			dstp[k]=(int)(value[sel_n][0]+0.5);
		}
		
	}//x̃[v
}//ỹ[v

//V
for (int y=2;y<height;y++) {
	//̗AẼ̗f[^荞
	lt=0;
	cn=1;
	i=srcp[(y-2)*srcpitch+3];
	j=srcp[(y-1)*srcpitch+3];
	k=srcp[ y   *srcpitch+3];
	ptn[cn][0]=0;
	ptn[cn][1]=    i;
	ptn[cn][2]=  j  ;
	//ptn[cn][3]=  j+i;
	ptn[cn][4]=k    ;
	//ptn[cn][5]=k  +i;
	//ptn[cn][6]=k+j  ;
	ptn[cn][7]=k+j+i;
	rt=2;
	i=srcp[(y-2)*srcpitch+7];
	j=srcp[(y-1)*srcpitch+7];
	k=srcp[ y   *srcpitch+7];
	ptn[rt][0]=0;
	ptn[rt][1]=    i;
	ptn[rt][2]=  j  ;
	//ptn[rt][3]=  j+i;
	ptn[rt][4]=k    ;
	//ptn[rt][5]=k  +i;
	//ptn[rt][6]=k+j  ;
	ptn[rt][7]=k+j+i;
	
	for (int x=11;x<rowsize;x+=4) {
		
		//EEẼVtg
		lt++;
		if (lt>2) lt=0;
		cn++;
		if (cn>2) cn=0;
		rt++;
		if (rt>2) rt=0;
		
		//Ẽf[^ǂݍ
		i=srcp[(y-2)*srcpitch+x];
		j=srcp[(y-1)*srcpitch+x];
		k=srcp[ y   *srcpitch+x];
		ptn[rt][0]=0;
		ptn[rt][1]=    i;
		ptn[rt][2]=  j  ;
		//ptn[rt][3]=  j+i;
		ptn[rt][4]=k    ;
		//ptn[rt][5]=k  +i;
		//ptn[rt][6]=k+j  ;
		ptn[rt][7]=k+j+i;
		
		//ꂼ̃GbWp^[EQ̕ϒl߂
		value[0][0]=(float)(ptn[lt][0]+ptn[cn][7]+ptn[rt][0])/3.0;
		value[0][1]=(float)(ptn[lt][7]+ptn[cn][0]+ptn[rt][0])/3.0;
		value[0][2]=(float)(ptn[lt][0]+ptn[cn][0]+ptn[rt][7])/3.0;
		value[1][0]=(float)(ptn[lt][2]+ptn[cn][2]+ptn[rt][2])/3.0;
		value[1][1]=(float)(ptn[lt][1]+ptn[cn][1]+ptn[rt][1])/3.0;
		value[1][2]=(float)(ptn[lt][4]+ptn[cn][4]+ptn[rt][4])/3.0;
		
		//]
		avg=(value[0][0]+value[0][1]+value[0][2])/3.0;
		tmp[0][0]=value[0][0]-avg;
		tmp[0][1]=value[0][1]-avg;
		tmp[0][2]=value[0][2]-avg;
		tmp[1][0]=value[1][0]-avg;
		tmp[1][1]=value[1][1]-avg;
		tmp[1][2]=value[1][2]-avg;
		sb[0]=tmp[0][0]*tmp[0][0]+tmp[0][1]*tmp[0][1]+tmp[0][2]*tmp[0][2];
		sb[1]=tmp[1][0]*tmp[1][0]+tmp[1][1]*tmp[1][1]+tmp[1][2]*tmp[1][2];
		sel_n = (sb[0]<sb[1]) ? 1 : 0;
		k=(y-1)*dstpitch+x-4;
		if (sb[sel_n]<th_/2) {
			dstp[k]=(int)(avg+0.5);
		} else {
			dstp[k]=(int)(value[sel_n][0]+0.5);
		}
		
	}//x̃[v
}//ỹ[v


//dst͏ĂȂ̂ŃtB^ΏۊO̍ŏ1sAŌ1sAŏ1f[^AŌ1f[^
  j=(height-1)*srcpitch;
  k=(height-1)*dstpitch;
  for (i=0;i<rowsize;i++)
    dstp[i]=srcp[i];
  for (i=0;i<rowsize;i++)
    dstp[k+i]=srcp[j+i];

  for (i=0;i<height;i++) {
    j=i*srcpitch;
    k=i*dstpitch;
    dstp[k]=srcp[j];
    dstp[k+1]=srcp[j+1];
    dstp[k+3]=srcp[j+3];
    dstp[k+rowsize-3]=srcp[j+rowsize-3];
    dstp[k+rowsize-2]=srcp[j+rowsize-2];
    dstp[k+rowsize-1]=srcp[j+rowsize-1];
  }

return dst;
}

AVSValue __cdecl Create_dw2DNR(AVSValue args, void* user_data, IScriptEnvironment* env) {
    return new dw2DNR(args[0].AsClip(),args[1].AsFloat(10), args[2].AsBool(false), env);
}

extern "C" __declspec(dllexport) const char* __stdcall AvisynthPluginInit2(IScriptEnvironment* env) {
    env->AddFunction("dw2DNR", "c[th]f[debug]b", Create_dw2DNR, 0);
    return "`dw2DNR' dw2DNR plugin";
}

/*
{
    char msg[256];
    sprintf(msg, "%d frame, sel_m=%d\n", n,sel_m);
    OutputDebugString(msg);
}
*/

